
-- VHDL Test Bench Created from source file dlabdio5.vhd -- 11:12:05 12/06/2002
--
-- Notes: 
-- This testbench has been automatically generated using types std_logic and
-- std_logic_vector for the ports of the unit under test.  Xilinx recommends 
-- that these types always be used for the top-level I/O of a design in order 
-- to guarantee that the testbench will bind correctly to the post-implementation 
-- simulation model.
--
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.numeric_std.ALL;

ENTITY testbench IS
END testbench;

ARCHITECTURE behavior OF testbench IS 

	COMPONENT dlabdio5
	PORT(
		db : IN std_logic_vector(7 downto 0);
		adr : IN std_logic_vector(3 downto 0);
		cs : IN std_logic;
		rgbBtn : IN std_logic_vector(9 downto 0);          
		encBtn : OUT std_logic_vector(3 downto 0);
		rgbLed : OUT std_logic_vector(15 downto 0);
		rgbSsgAn : OUT std_logic_vector(3 downto 0);
		rgbSsgCa : OUT std_logic_vector(7 downto 0)
		);
	END COMPONENT;

	SIGNAL db :  std_logic_vector(7 downto 0);
	SIGNAL adr :  std_logic_vector(3 downto 0);
	SIGNAL cs :  std_logic;
	SIGNAL rgbBtn :  std_logic_vector(9 downto 0);
	SIGNAL encBtn :  std_logic_vector(3 downto 0);
	SIGNAL rgbLed :  std_logic_vector(15 downto 0);
	SIGNAL rgbSsgAn :  std_logic_vector(3 downto 0);
	SIGNAL rgbSsgCa :  std_logic_vector(7 downto 0);

BEGIN

	uut: dlabdio5 PORT MAP(
		db => db,
		adr => adr,
		cs => cs,
		rgbBtn => rgbBtn,
		encBtn => encBtn,
		rgbLed => rgbLed,
		rgbSsgAn => rgbSsgAn,
		rgbSsgCa => rgbSsgCa
	);


-- *** Test Bench - User Defined Section ***
tb : PROCESS
    BEGIN
        cs <= '0';
        adr <= "0000";
        rgbBtn <= "0000000000";
        db <= "00000000";

        wait for 100 ns;

        -- Check that the CS gates writing to the latches

        adr(0) <= '1';
        wait for 100 ns;
        adr(0) <= '0';
        wait for 100 ns;

        -- Check writing to each of the latches

        cs <= '1';
        db <= "01010101";
        adr(0) <= '1';
        wait for 100 ns;
        db <= "10101010";
        wait for 100 ns;
        cs <= '0';
        adr(0) <= '0';
        
        cs <= '1';
        db <= "01010101";
        adr(1) <= '1';
        wait for 100 ns;
        db <= "10101010";
        wait for 100 ns;
        cs <= '0';
        adr(1) <= '0';
        
        cs <= '1';
        db <= "01010101";
        adr(2) <= '1';
        wait for 100 ns;
        db <= "10101010";
        wait for 100 ns;
        cs <= '0';
        adr(2) <= '0';
        
        cs <= '1';
        db <= "01010101";
        adr(3) <= '1';
        wait for 100 ns;
        db <= "10101010";
        wait for 100 ns;
        cs <= '0';
        adr(3) <= '0';
        
        -- Check the button encoder

        rgbBtn(0) <= '1';
        wait for 100 ns;
        rgbBtn(0) <= '0';
        wait for 100 ns;

        rgbBtn(1) <= '1';
        wait for 100 ns;
        rgbBtn(1) <= '0';
        wait for 100 ns;

        rgbBtn(2) <= '1';
        wait for 100 ns;
        rgbBtn(2) <= '0';
        wait for 100 ns;

        rgbBtn(3) <= '1';
        wait for 100 ns;
        rgbBtn(3) <= '0';
        wait for 100 ns;

        rgbBtn(4) <= '1';
        wait for 100 ns;
        rgbBtn(4) <= '0';
        wait for 100 ns;

        rgbBtn(5) <= '1';
        wait for 100 ns;
        rgbBtn(5) <= '0';
        wait for 100 ns;

        rgbBtn(6) <= '1';
        wait for 100 ns;
        rgbBtn(6) <= '0';
        wait for 100 ns;

        rgbBtn(7) <= '1';
        wait for 100 ns;
        rgbBtn(7) <= '0';
        wait for 100 ns;

        rgbBtn(8) <= '1';
        wait for 100 ns;
        rgbBtn(8) <= '0';
        wait for 100 ns;

        rgbBtn(9) <= '1';
        wait for 100 ns;
        rgbBtn(9) <= '0';
        wait for 100 ns;

        -- Test multiple simultaneous button presses

        rgbBtn(0) <= '1';
        rgbBtn(1) <= '1';
        wait for 100 ns;
        rgbBtn(2) <= '1';
        wait for 100 ns;
        rgbBtn(3) <= '1';
        wait for 100 ns;

        rgbBtn(0) <= '0';
        rgbBtn(1) <= '0';
        rgbBtn(2) <= '0';


        wait; -- will wait forever
    END PROCESS;
-- *** End Test Bench - User Defined Section ***

END;
